{
Copyright (C) 2002-2010  Massimo Melina (www.rejetto.com)

This file is part of HFS ~ HTTP File Server.

    HFS is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    HFS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with HFS; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
}
unit optionsDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Grids, ComCtrls, ValEdit, types, main, CheckLst, UnitScrollingLabel, JvExControls, JvScrollText, JvExForms,
  JvScrollBox, Buttons, JvExButtons, JvBitBtn, JvBaseDlg, JvDesktopAlert;

type
  ToptionsFrm = class(TForm)
    pageCtrl: TPageControl;
    bansPage: TTabSheet;
    accountsPage: TTabSheet;
    accountpropGrp: TGroupBox;
    accountenabledChk: TCheckBox;
    pwdBox: TLabeledEdit;
    Label1: TLabel;
    deleteaccountBtn: TButton;
    renaccountBtn: TButton;
    mimePage: TTabSheet;
    mimeBox: TValueListEditor;
    trayPage: TTabSheet;
    Label2: TLabel;
    traymsgBox: TMemo;
    Panel1: TPanel;
    Label3: TLabel;
    accountAccessBox: TTreeView;
    Panel2: TPanel;
    okBtn: TButton;
    applyBtn: TButton;
    cancelBtn: TButton;
    bansBox: TValueListEditor;
    addBtn: TButton;
    deleteBtn: TButton;
    Panel3: TPanel;
    noreplybanChk: TCheckBox;
    a2nPage: TTabSheet;
    Panel4: TPanel;
    Label4: TLabel;
    a2nBox: TValueListEditor;
    ignoreLimitsChk: TCheckBox;
    Panel5: TPanel;
    addMimeBtn: TButton;
    deleteMimeBtn: TButton;
    deleteA2Nbtn: TButton;
    addA2Nbtn: TButton;
    iconsPage: TTabSheet;
    iconMasksBox: TMemo;
    iconsBox: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    JvScrollBox1: TJvScrollBox;
    redirBox: TLabeledEdit;
    inBrowserIfMIMEchk: TCheckBox;
    traypreviewBox: TMemo;
    Label10: TLabel;
    accountLinkBox: TLabeledEdit;
    groupChk: TCheckBox;
    groupsBtn: TButton;
    addaccountBtn: TButton;
    upBtn: TButton;
    downBtn: TButton;
    sortBtn: TButton;
    accountsBox: TListBox;
    inPlaceEditBox: TEdit;
    JvScrollText1: TScrollingLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Button1: TJvBitBtn;
    notesBox: TMemo;
    Label7: TLabel;
    Image9: TImage;
	MembersBtn: TButton;
    JvDesktopAlert1: TJvDesktopAlert;   //add by SilentPliz
	sortBanBtn: TButton;
    notesWrapChk: TCheckBox;
    AccountHintActivate: TCheckBox;  //add by SilentPliz
    Image10: TImage;  //add by SilentPliz
    AccountHelp: TJvBitBtn;  //add by SilentPliz
    Image11: TImage;  //add by SilentPliz
    Image12: TImage;  //add by SilentPliz
    Image13: TImage;  //add by SilentPliz
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure addaccountBtnClick(Sender: TObject);
    procedure deleteaccountBtnClick(Sender: TObject);
    procedure accountsBoxEdited(Sender: TObject; Item: TListItem; var S: String);
    procedure renaccountBtnClick(Sender: TObject);
    procedure accountsBoxKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure accountAccessBoxDblClick(Sender: TObject);
    procedure accountAccessBoxContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure cancelBtnClick(Sender: TObject);
    procedure okBtnClick(Sender: TObject);
    procedure applyBtnClick(Sender: TObject);
    procedure addBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure deleteBtnClick(Sender: TObject);
    procedure pwdBoxEnter(Sender: TObject);
    procedure pwdBoxExit(Sender: TObject);
    procedure addMimeBtnClick(Sender: TObject);
    procedure deleteMimeBtnClick(Sender: TObject);
    procedure addA2NbtnClick(Sender: TObject);
    procedure deleteA2NbtnClick(Sender: TObject);
    procedure iconsBoxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure iconsBoxDropDown(Sender: TObject);
    procedure iconsBoxChange(Sender: TObject);
    procedure iconMasksBoxChange(Sender: TObject);
    procedure wiki(Sender: TObject);	  //add by SilentPliz
    procedure traymsgBoxChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure accountsBoxMouseMove(Sender: TObject;// BY MARS
    Shift: TShiftState; X, Y: Integer);
    procedure accountsPageEnter(Sender: TObject);// BY MARS
    procedure accountLinkBoxExit(Sender: TObject);
    procedure groupChkClick(Sender: TObject);
    procedure groupsBtnClick(Sender: TObject);
    procedure accountenabledChkClick(Sender: TObject);
    procedure upBtnClick(Sender: TObject);
    procedure sortBtnClick(Sender: TObject);
    procedure accountsBoxDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure accountsBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure accountsBoxData(Control: TWinControl; Index: Integer;
      var Data: string);
    procedure accountsBoxClick(Sender: TObject);
    procedure inPlaceEditBoxExit(Sender: TObject);
    procedure inPlaceEditBoxKeyPress(Sender: TObject; var Key: Char);
    procedure upBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure accountsBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure accountsBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure accountsBoxDblClick(Sender: TObject);   // BY MARS
    procedure inPlaceEditBoxChange(Sender: TObject);
    procedure notesBoxChange(Sender: TObject);
    procedure MembersBtnClick(Sender: TObject);
	procedure sortBanBtnClick(Sender: TObject);
    procedure notesWrapChkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AccountHelpClick(Sender: TObject); //add by SilentPliz
    procedure ignoreLimitsChkClick(Sender: TObject);
  public
	procedure loadAccountProperties();
    function saveAccountProperties():boolean;
    procedure deleteAccount(idx:integer=-1);
    procedure loadValues();
    function  saveValues():boolean; // it may fail on incorrect input
    function  checkValues():string; // returns an error message
    procedure updateIconMap();
    procedure updateIconsBox();
    procedure selectAccount(i:integer; saveBefore:boolean=TRUE);
  end;

var
  optionsFrm: ToptionsFrm;
  pointedAccount: integer = -1;

implementation

{$R *.dfm}

uses
  utilLib, HSlib, strUtils, classesLib, listSelectDlg;

var
  lastAccountSelected: integer = -1; // stores the previous selection index
  tempAccounts: Taccounts; // the GUI part can't store the temp data
  tempIcons: array of integer;
  margin: integer;
  itemOver:integer=-1;      //add by mars
  itemRect:Trect;           //add by mars

procedure ToptionsFrm.selectAccount(i:integer; saveBefore:boolean=TRUE);
begin
if saveBefore then saveAccountProperties();
accountsBox.itemIndex:=i;
loadAccountProperties();
end; // selectAccount

procedure ToptionsFrm.loadValues();
var
  i:integer;
begin
// bans
noreplybanChk.checked:=noReplyBan;
bansBox.Strings.Clear();
for i:=0 to length(banList)-1 do
	bansBox.strings.Add(banList[i].ip+'='+banlist[i].comment);
// mime types
inBrowserIfMIMEchk.Checked:=inBrowserIfMIME;
mimeBox.Strings.Clear();
for i:=0 to length(DEFAULT_MIME_TYPES) div 2-1 do
	mimeBox.strings.add(DEFAULT_MIME_TYPES[i*2]+'='+DEFAULT_MIME_TYPES[i*2+1]);
for i:=0 to length(mimeTypes) div 2-1 do
	mimeBox.strings.add(mimeTypes[i*2]+'='+mimeTypes[i*2+1]);
// address2name
a2nBox.Strings.clear();
for i:=0 to length(address2name) div 2-1 do
	a2nBox.strings.Add(address2name[i*2]+'='+address2name[i*2+1]);
// tray message
traymsgBox.Text:=xtpl(trayMsg,[#13,CRLF]);
// accounts
lastAccountSelected:=-1;
// remember original name for tracking possible later renaming
for i:=0 to length(accounts)-1 do
  with accounts[i] do wasUser:=user;
accountsBox.count:=length(accounts);
tempAccounts:=accounts;
setLength(tempAccounts, length(tempAccounts)); // unlink from the source
lastAccountSelected:=-1;
loadAccountProperties();
// icons
updateIconsBox();
i:=length(iconMasks);
setLength(tempIcons, i+1);
iconMasksBox.Text:='';
for i:=0 to i-1 do
  begin
  iconMasksBox.lines.Add(iconMasks[i].str);
  tempIcons[i]:=iconMasks[i].int;
  end;
iconMasksBox.SelStart:=0;
  end; 
procedure ToptionsFrm.notesBoxChange(Sender: TObject);
begin 
end; // loadValues

procedure ToptionsFrm.notesWrapChkClick(Sender: TObject);
begin
notesBox.WordWrap:=notesWrapChk.checked;
if notesBox.WordWrap then
  notesBox.ScrollBars:=ssVertical
else
  notesBox.ScrollBars:=ssBoth
end;

function ToptionsFrm.checkValues():string;
var
  i: integer;
  s: string;
begin
for i:=bansBox.Strings.count downto 1 do
  begin
  bansbox.cells[0,i]:=trim(bansbox.cells[0,i]);
  s:=bansbox.cells[0,i];
  if s = '' then continue;
  if bansBox.strings.indexOfName(s)+1 < i then
    begin
	result:=format('La Barrire : "%s" est duplique', [s]);
    exit;
    end;
  if not checkAddressSyntax(s) then
    begin
result:=format('Barrire : erreur de syntaxe pour "%s"', [s]);
    exit;
    end;
  end;
for i:=a2nBox.Strings.count downto 1 do
  begin
  s:=trim(a2nBox.cells[1,i]);
  if trim(s+a2nBox.cells[0,i]) = '' then
    a2nBox.DeleteRow(i)
  else
    if (s>'') and not checkAddressSyntax(s) then
      begin
      result:=format('Addresse vers Nom : erreur de syntaxe pour "%s"', [s]);
      exit;
      end;
  end;
result:='';
end; // checkValues

function ToptionsFrm.saveValues():boolean;
var
  i, n: integer;
  s: string;
begin
result:=FALSE;
s:=checkValues();
if s > '' then
  begin
  msgDlg(s, MB_ICONERROR);
  exit;
  end;
if not saveAccountProperties() then exit;
// bans
noReplyBan:=noreplybanChk.checked;
i:=bansbox.Strings.Count;
if bansbox.Cells[0,i] = '' then dec(i);
setlength(banlist, i);
n:=0;
for i:=0 to length(banlist)-1 do
  begin
  banlist[i].ip:=trim(bansBox.Cells[0,i+1]);
  if banlist[i].ip = '' then continue
  else inc(n);
  banlist[i].comment:=bansBox.Cells[1,i+1];
  end;
setlength(banlist, n);
kickBannedOnes();
// mime types
inBrowserIfMIME:=inBrowserIfMIMEchk.checked;
mimeTypes:=NIL;
for i:=1 to mimebox.rowCount-1 do
  addArray(mimeTypes, [mimeBox.cells[0,i], mimeBox.cells[1,i]]);
removeDefaultMimeTypes();

// address2name
address2name:=NIL;
for i:=1 to a2nBox.RowCount-1 do
  begin
  s:=trim(a2nBox.Cells[1,i]);
  if s > '' then addArray(address2name, [a2nBox.Cells[0,i], s]);
  end;
// tray message
trayMsg:=xtpl(traymsgBox.Text, [#10,'']);
// accounts
accounts:=tempAccounts;
purgeVFSaccounts();
mainfrm.filesBox.repaint();
// icons
n:=0;
for i:=0 to iconMasksBox.Lines.Count-1 do
  begin
  s:=iconMasksBox.Lines[i];
  if trim(s) = '' then continue;
  inc(n);
  setlength(iconMasks, n);
  iconMasks[n-1].str:=s;
  iconMasks[n-1].int:=tempIcons[i];
  end;
result:=TRUE;
end; // saveValues

function ipListComp(list: TStringList; index1, index2: integer):integer;

  function extract(s:string; var o:integer):string;
  var
    i: integer;
  begin
  i:=posEx('.',s,o);
  if i = 0 then i:=length(s)+1;
  result:=substr(s,o,i-1);
  o:=i+1;
  end; // extract

  function compare(a,b:string):integer;
  begin
  try result:=compare_(strToInt(a), strToInt(b));
  except
    result:=compare_(length(a), length(b));
    if result = 0 then
      result:=ansiCompareStr(a,b);
    end;
  end; // compare

var
  o1, o2: integer;
  s1, s2: string;
begin
s1:=getTill('=', list[index1]);
s2:=getTill('=', list[index2]);
o1:=1;
o2:=1;
  repeat
  result:=compare(extract(s1,o1), extract(s2,o2));
  until (result <> 0) or (o1 > length(s1)) and (o2 > length(s2));
end; // ipListComp

procedure ToptionsFrm.sortBanBtnClick(Sender: TObject);
begin
(bansbox.strings as TstringList).customSort(ipListComp);
end;

procedure ToptionsFrm.sortBtnClick(Sender: TObject);

  function sortIt(reverse:boolean=FALSE):boolean;
  var
    s, i, j, l: integer;
  begin
  result:=FALSE;
  s:=accountsBox.ItemIndex;
  l:=length(tempAccounts);
  for i:=0 to l-2 do
    for j:=i+1 to l-1 do
      if reverse XOR (compareText(tempAccounts[i].user, tempAccounts[j].user) > 0) then
        begin
        swapMem(tempAccounts[i], tempAccounts[j], sizeof(tempAccounts[0]));
        if i = s then
          s:=j
        else if j = s then
          s:=i;
        result:=TRUE;
        end;
  accountsBox.ItemIndex:=s;
  end; // sortIt

begin
lastAccountSelected:=-1;
if not sortIt(FALSE) then sortIt(TRUE);
accountsBox.invalidate();
end;

procedure ToptionsFrm.traymsgBoxChange(Sender: TObject);
begin traypreviewBox.text:=mainfrm.getTrayTipMsg(traymsgBox.text) end;

procedure ToptionsFrm.FormShow(Sender: TObject);
var
  i: integer;
  s: string;
begin
i:=round(mainfrm.images.Height*1.25);     //mars
accountsBox.ItemHeight:= round(i*0.9);    //mars
margin:=i div 10;                         //mars
// setwindowlong(handle, GWL_HWNDPARENT, 0); // get a taskbar button  mod by SilentPliz
loadValues();
if pageCtrl.activePage <> a2nPage then exit;
s:=mainfrm.ipPointedInLog();
if s = '' then exit;
// select row or insert new one
i:=length(address2name)-1;
while (i > 0) and not addressmatch(address2name[i], s) do
  dec(i, 2);
if i <= 0 then a2nBox.row:=a2nBox.insertRow('',s,TRUE)
else
  try a2nBox.Row:=i
  except end; // this should not happen, but in case (it was reported once) just skip selecting

a2nBox.SetFocus();
a2nBox.EditorMode:=TRUE;
end;

procedure ToptionsFrm.groupChkClick(Sender: TObject);
begin
Image12.visible:=not groupChk.checked; //add by SilentPliz
Image3.visible:= groupChk.checked; //add by SilentPliz
pwdBox.visible:=not groupChk.checked;
Image5.visible:=not groupChk.checked; //add by SilentPliz
accountsBox.invalidate();
end;

procedure ToptionsFrm.FormActivate(Sender: TObject);
begin
traymsgBoxChange(NIL);
end;

procedure ToptionsFrm.accountsBoxMouseMove(Sender: TObject; Shift: TShiftState;//add by mars
  X, Y: Integer);
begin
with accountsbox do
  begin
  ShowHint:=True;
  pointedAccount:=ItematPos(point(x,y), FALSE);
  end;
end;

procedure ToptionsFrm.accountsPageEnter(Sender: TObject);//add by mars
begin
accountsbox.setfocus;
end;

procedure ToptionsFrm.FormCreate(Sender: TObject);
begin
notesWrapChk.Checked:=TRUE;
end;

procedure ToptionsFrm.FormResize(Sender: TObject);
begin bansBox.ColWidths[1]:=bansBox.ClientWidth-bansBox.colWidths[0]-2 end;

procedure setEnabledRecur(c:Tcontrol; v:boolean);
var
  i: integer;
begin
c.enabled:=v;
if c is TTreeView then
  (c as TTreeView).items.clear();
if c is TLabeledEdit then
  (c as TLabeledEdit).text:='';
if c is Tmemo then
  (c as Tmemo).text:='';
if c is Tcheckbox then
  (c as Tcheckbox).checked:=FALSE;

if c is Twincontrol then
  with c as Twincontrol do
    for i:=0 to controlCount-1 do
    	setEnabledRecur(controls[i], v);
end; // setEnabledRecur

procedure ToptionsFrm.loadAccountProperties();
const
  FILEACTION2STR: array [TfileAction] of string = ('tlchargement', 'suppression', 'envoi');   //mars
var
  a, other: Paccount;
  b, bakWrap: boolean;
  n: Ttreenode;
  f: Tfile;
  props: TstringDynArray;
  act: TfileAction;
  s: string;
  i: integer;

begin
lastAccountSelected:=accountsBox.ItemIndex;
b:=lastAccountSelected >= 0;
bakWrap:=notesWrapChk.checked;
setEnabledRecur(accountpropGrp, b);
notesWrapChk.checked:=bakWrap;
renAccountBtn.enabled:=b;
deleteAccountBtn.enabled:=b;
upBtn.Enabled:=b;
downBtn.enabled:=b;

if not accountpropGrp.Enabled then exit;
a:=@tempAccounts[lastAccountSelected];
accountEnabledChk.checked:=a.enabled;
pwdBox.Text:=a.pwd;
groupChk.Checked:=a.group;
membersBtn.Enabled:=a.group;
accountLinkBox.text:=join(';',a.link);
ignoreLimitsChk.Checked:=a.noLimits;
redirBox.Text:=a.redir;
notesBox.text:=a.notes;

groupsBtn.enabled:=FALSE;;
for i:=0 to length(tempAccounts)-1 do
  if tempAccounts[i].group and (i <> accountsBox.itemIndex) then
    groupsBtn.enabled:=TRUE;

accountAccessBox.items.clear();
n:=rootNode;
while n <> NIL do
  begin
  f:=Tfile(n.data);
  n:=n.getNext();
  if f =  NIL then continue;

  props:=NIL;
  for act:=low(TfileAction) to high(TfileAction) do
    begin
    s:=FILEACTION2STR[act];
    // any_account will suffice, otherwise our username (or a linked one) must be there explicitly, otherwise the resource is not protected or we have no access and thus must not be listed
    if not stringExists(USER_ANY_ACCOUNT, f.accounts[act]) then
      begin
      other:=findEnabledLinkedAccount(a, f.accounts[act]);
      if other = NIL then continue;
      if other <> a then
        s:=s+' via '+other.user;
      end;
    addString(s, props);
    end;
  if props = NIL then continue;

  with accountAccessBox.items.addObject(NIL, f.name+' ['+join(', ',props)+']', f.node) do
    begin
    imageIndex:=f.node.imageIndex;
    selectedIndex:=imageIndex;
    end;
  end;
end; // loadAccountProperties

function ToptionsFrm.saveAccountProperties():boolean;
const
  MSG_CHARS = 'Les caractres suivants ne sont pas admis'
    +#13'/\:?*"<>|;&&@';
  MSG_PWD = 'Mot de passe incorrect.'#13+MSG_CHARS;
var
  a: Paccount;
begin
result:=TRUE;
if lastAccountSelected < 0 then exit;
result:=FALSE;
if not validUsername(pwdbox.Text, TRUE) then
  begin
	msgDlg(MSG_PWD, MB_ICONERROR);
  exit;
  end;

a:=@tempAccounts[lastAccountSelected];
a.enabled:=accountEnabledChk.checked;
a.pwd:=pwdBox.Text;
a.noLimits:=ignoreLimitsChk.checked;
a.redir:=redirBox.Text;
a.notes:=notesBox.text;
a.link:=split(';', trim(accountLinkBox.text));
a.group:=groupChk.Checked;
uniqueStrings(a.link);
result:=TRUE;
accountsBox.invalidate();
end; // saveAccountProperties

function findUser(user:string):integer;
begin
result:=length(tempAccounts)-1;
while (result >= 0) and not sameText(tempAccounts[result].user, user) do
  dec(result);
end; // findUser

function userExists(user:string):boolean; overload;
begin result:=findUser(user) >= 0 end;

function userExists(user:string; excpt:integer):boolean; overload;
var
  i: integer;
begin
i:=findUser(user);
result:=(i >= 0) and (i <> excpt);
end;

procedure ToptionsFrm.addaccountBtnClick(Sender: TObject);
var
  i: integer;
  a: Taccount;
begin
a.user:=getUniqueName('Nouveau Compte', userExists);
a.pwd:='';
a.enabled:=TRUE;
a.noLimits:=FALSE;
a.redir:='';

i:=length(tempAccounts);
setLength(tempAccounts, i+1);
tempAccounts[i]:=a;
accountsBox.count:=i+1;
selectAccount(i);

renaccountBtnClick(sender);
end;

procedure ToptionsFrm.deleteAccount(idx:integer=-1);
var
  i: integer;
begin
if idx < 0 then
	begin
  idx:=accountsBox.itemIndex;
  if idx < 0 then exit;
 	if msgDlg('Voulez-vous vraiment supprimer ce Compte ?', MB_ICONQUESTION+MB_YESNO) = IDNO then
  	exit;
  end;
// shift
for i:=idx+1 to length(tempAccounts)-1 do
  tempAccounts[i-1]:=tempAccounts[i];
// shorten
accountsBox.items.delete(idx);
setlength(tempAccounts, length(tempAccounts)-1);
selectAccount(min(idx, accountsbox.items.Count-1), FALSE);
accountsBox.invalidate();
end; // deleteAccount

procedure ToptionsFrm.deleteaccountBtnClick(Sender: TObject);
begin deleteAccount() end;

procedure swapItems(i, j :integer); //mod by mars NE RIEN TOUCHER DE CETTE PROCEDURE
var
  idx ,s: integer;                // mod by mars
begin
s:=length(tempAccounts)-1;
if not inRange(0, i, s) or not inRange(0, j, s) or ( i = j ) then exit;  //mod by mars
s:=optionsFrm.accountsBox.itemIndex;
lastAccountSelected:=-1; // avoid data saving from fields while moving
{mod by mars}
//swapMem(tempAccounts[i], tempAccounts[j], sizeof(tempAccounts[i]));  //removed by mars
if i < j  then
    for idx := i to j - 1 do
      swapMem(tempAccounts[idx], tempAccounts[idx+1], sizeof(tempAccounts[idx]))
  else
    for idx := i downto j + 1 do
      swapMem(tempAccounts[idx], tempAccounts[idx-1], sizeof(tempAccounts[idx]));
{end mod by mars}
if i = s then
  s:=j
else if j = s then
  s:=i;
with optionsFrm.accountsBox do
  begin
  itemIndex:=s;
  //**selected.focused:=TRUE;
  invalidate();
  end;
end; // swapItems

procedure ToptionsFrm.accountsBoxClick(Sender: TObject);
begin
if inPlaceEditBox.visible then
  accountsBox.ItemIndex:=lastAccountSelected
else
  selectAccount(accountsBox.ItemIndex);
end;

procedure ToptionsFrm.accountsBoxData(Control: TWinControl; Index: Integer; var Data: string);
var
  p: Paccount;
begin
if not inRange(0, index, length(tempAccounts)-1) then exit;
p:=@tempAccounts[index];
data:=p.user;
end;

procedure ToptionsFrm.accountsBoxDblClick(Sender: TObject);      //add by mars
begin
renaccountBtnClick(renaccountBtn);
end;

procedure ToptionsFrm.accountsBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
accountsbox.Canvas.pen.color:=clWindow;     //add by mars
accountsbox.Canvas.pen.Style:=psSolid;      //add by mars
accountsbox.Canvas.Rectangle(itemrect);     //add by mars
swapItems(accountsBox.ItemIndex,accountsBox.ItemAtPos(point(x,y), TRUE));  //mod by mars   (swap of parameters)  NE PAS TOUCHER
end;

procedure ToptionsFrm.accountsBoxDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  i,y1,j:integer;  //add by mars
begin
{add by mars}
accountsBox.Canvas.pen.Style:=psSolid;
if itemover<> accountsBox.ItemAtPos(point(x,y), TRUE) then
  begin
  accountsBox.Canvas.pen.color:=clWindow;
  accountsBox.Canvas.Rectangle(itemRect);
  itemOver:= accountsBox.ItemAtPos(point(x,y), TRUE);
  end;
i:=accountsBox.ItemAtPos(point(x,y), TRUE);
j:=min(safeDiv(accountsbox.Height,accountsbox.ItemHeight)+accountsbox.topindex,accountsbox.count-1);
if i=accountsbox.topindex then
     accountsbox.topindex:=-min(-i+1,0);
if i=j-1 then
     accountsbox.topindex:=accountsbox.TopIndex+1;
y1:=accountsBox.ItemHeight*if_(i<accountsBox.ItemIndex,i-accountsbox.TopIndex,i-accountsbox.TopIndex+1)+1;
itemrect.left:=20;
itemrect.Top:=y1;
itemrect.right:=accountsBox.width-10;
itemrect.Bottom:=y1+2;
if i<> accountsBox.ItemIndex then
  begin
  accountsBox.Canvas.pen.color:=clActiveCaption;
  accountsBox.Canvas.Rectangle(itemrect);
  end;
{end by mars}
accept:=(sender = source) and (accountsBox.ItemAtPos(point(x,y), TRUE) >= 0);
end;

procedure ToptionsFrm.accountsBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);

  Function TextSize(Phrase : string; Police : TFont = nil) : TPoint;
  var
    DC: HDC;
    Rect: TRect;
    C : TBitmap;
  begin
  C := TBitmap.create;
  if police <> nil then  C.canvas.Font := police;
    Rect.Left := 0;
    Rect.Top:=0;
    Rect.Right:=0;
    Rect.Bottom:=0;
    DC := GetDC(0);
    C.Canvas.Handle := DC;
    DrawText(C.Canvas.Handle, PChar(Phrase), Length(Phrase), Rect, (DT_EXPANDTABS or DT_CALCRECT));
    C.Canvas.Handle := 0;
    ReleaseDC(0, DC);
    result.X:=Rect.Right-Rect.Left;
    result.Y:=Rect.Bottom-Rect.Top;
    C.Free;
  end;

var
  c: Tcanvas;
  a: Paccount;
  i: integer;   //add by mars
begin
c:=accountsBox.Canvas;
a:=@tempAccounts[index];

c.TextRect(rect, rect.left+margin*(10+2+1), rect.top+margin, a.user);
mainfrm.images.Draw(c, rect.Left+margin*2, rect.top+margin,
  accountIcon(
    if_(index=accountsBox.itemIndex, accountenabledChk.checked, a.enabled),
    if_(index=accountsBox.itemIndex, groupChk.checked, a.group)
  )
);
for i:= 0 to accountsbox.count - 1 do             //add by mars
  accountsbox.ScrollWidth:=-min(-textsize(accountsbox.Items.Strings[i],accountsbox.Canvas.Font).X-32,-accountsbox.ScrollWidth);   ///add by mars
end;

//  MARS : NOT USED IN FRENCH VERSION   ToptionsFrm.accountsBoxEdited
procedure ToptionsFrm.accountsBoxEdited(Sender: TObject; Item: TListItem; var S: String);

  function existing():boolean;
  var
    i: integer;
  begin
  result:=TRUE;
  for i:=0 to length(tempAccounts)-1 do
    if compareText(s, tempAccounts[i].user) = 0 then
      exit;
  result:=FALSE;
  end; // existing

var
  old: ^string;
  b: boolean;
  i: integer;
begin
{mod by mars}
old:=@tempAccounts[item.Index].user;
b:=not validUsername(s);
if b or existing() then
  begin
  msgDlg(if_(b,'Nom d''utilisateur invalide','Nom d''utilisateur dupliqu'), MB_ICONERROR);
  s:=old^;
  exit;
  end;
{/mod}
for i:=0 to length(tempAccounts)-1 do
  replaceString(tempAccounts[i].link, old^, s);
old^:=s;
end; // accountsBoxEdited
// mars :ToptionsFrm.accountsBoxEdited

procedure ToptionsFrm.renaccountBtnClick(Sender: TObject);
var
  r: Trect;
begin
if accountsBox.ItemIndex < 0 then exit;
r:=accountsBox.ItemRect(accountsBox.ItemIndex);
r.topLeft:=accountsBox.clientToParent(r.TopLeft, inPlaceEditBox.Parent);
r.BottomRight:=accountsBox.clientToParent(r.BottomRight, inPlaceEditBox.Parent);
inc(r.Left, margin*12);
inPlaceEditBox.setBounds(r.Left+2, r.Top+2, r.Right-r.left, r.Bottom-r.top+1);
inPlaceEditBox.Text:=tempAccounts[accountsBox.itemIndex].user;
inPlaceEditBox.selectAll();
inPlaceEditBox.BorderStyle:=bsNone;
inPlaceEditBox.BevelKind:=bkTile;
inPlaceEditBox.show();
inPlaceEditBox.setFocus();
//**accountsBox.selected.editCaption()
end;

procedure ToptionsFrm.accountLinkBoxExit(Sender: TObject);
const
MSG_MISSING_USERS = 'Ces noms d''utilisateurs lis sont introuvables: %s'
    +#13'Ceci est anormal, mais vous pourrez les ajouter ensuite.';
var
  users, missing: TStringDynArray;
  i: integer;
begin
users:=split(';', trim(accountLinkBox.text));
// check for non-existent linked account
missing:=NIL;
for i:=0 to length(users)-1 do
  if not userExists(users[i]) then
    addString(users[i], missing);
if assigned(missing) then
  msgDlg(format(MSG_MISSING_USERS, [join(', ', missing)]), MB_ICONWARNING);
// the following is to refresh the access preview box. You may think this saving may cause some settings to be applied, or some undo possibility to be lost, but this is not true: values are saved to temp memory.
selectAccount(accountsBox.ItemIndex);
end;

procedure ToptionsFrm.accountsBoxKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
if inPlaceEditBox.Visible then exit;
if shift = [] then
	case key of
  	VK_F2: renaccountBtn.click();
    VK_INSERT: addaccountBtn.click(); // mod by mars
    VK_DELETE: deleteAccount();
    end;
{mod by mars}
if shift = [ssAlt] then
  case key of
    VK_UP: upBtn.click();
    VK_DOWN: downBtn.Click();
    end;
{/mod}
end;

procedure ToptionsFrm.accountsBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if accountsBox.ItemAtPos(point(x,y), TRUE) < 0 then
  selectAccount(-1);
end;

procedure ToptionsFrm.accountAccessBoxDblClick(Sender: TObject);
begin
with sender as Ttreeview do
  begin
  if selected = NIL then exit;
  mainfrm.filesBox.selected:=selected.Data;
  mainfrm.setFocus();
  end;
end;

procedure ToptionsFrm.accountenabledChkClick(Sender: TObject);
begin
Image11.visible:=not accountenabledChk.checked; //add by SilentPliz
Image4.visible:= accountenabledChk.checked; //add by SilentPliz
accountsBox.invalidate()
end;

procedure ToptionsFrm.AccountHelpClick(Sender: TObject);   //add by SilentPliz
begin
mainFrm.JvDesktopAlert35.Execute;
end;

procedure ToptionsFrm.accountAccessBoxContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
with sender as Ttreeview do
  if selected = NIL then handled:=TRUE
  else mainfrm.filesBox.selected:=selected.data;
end;

procedure ToptionsFrm.cancelBtnClick(Sender: TObject);
begin close() end;

procedure ToptionsFrm.applyBtnClick(Sender: TObject);
begin saveValues() end;

procedure ToptionsFrm.okBtnClick(Sender: TObject);
begin if saveValues() then close() end;

procedure ToptionsFrm.Button1Click(Sender: TObject);   //add by SilentPliz
begin JvDesktopAlert1.Execute; end;

procedure ToptionsFrm.MembersBtnClick(Sender: TObject);       //add by mars 2009
var
  i: integer;
  groups: TstringList;
  s: string;
begin
groups:=TstringList.create;
s:=tempAccounts[accountsBox.itemIndex].user;
try
  for i:=0 to length(tempAccounts)-1 do
    if (i <> accountsBox.itemIndex) then
      begin
      groups.AddObject(tempAccounts[i].user, if_(stringExists(s, tempAccounts[i].link), PTR1, NIL));
      end;
  if not listSelect('Comptes Li'#233's', groups) then exit;
  for i:=0 to accountsBox.itemIndex -1 do
   begin
    if groups.Objects[i] = NIL then removestring(s,tempAccounts[i].link)
      else adduniquestring(s,tempAccounts[i].link);
   end;
  for i:=accountsBox.itemIndex to groups.Count -1 do
   begin
    if groups.Objects[i] = NIL then removestring(s,tempAccounts[i+1].link)
      else adduniquestring(s,tempAccounts[i+1].link);
   end;
finally groups.free end;
end;

procedure ToptionsFrm.groupsBtnClick(Sender: TObject);
var
  i: integer;
  there: TStringDynArray;
  groups: TstringList;
  s: string;
begin
there:=split(';', accountLinkBox.Text);
groups:=TstringList.create;
try
  for i:=0 to length(tempAccounts)-1 do
    if tempAccounts[i].group and (i <> accountsBox.itemIndex) then
      begin
      s:=tempAccounts[i].user;
      groups.AddObject(s, if_(stringExists(s, there), PTR1, NIL));
      end;
  if not listSelect('Slection des groupes', groups) then exit;
  s:='';
  for i:=0 to groups.Count-1 do
    if groups.Objects[i] <> NIL then
      s:=s+groups[i]+';';
  accountLinkBox.Text:=getTill(-1, s);
finally groups.free end;
end;

procedure ToptionsFrm.pwdBoxEnter(Sender: TObject);
begin if pwdBox.Text > '' then pwdBox.passwordChar:=#0 end;

procedure ToptionsFrm.pwdBoxExit(Sender: TObject);
begin pwdBox.passwordChar:='*' end;

procedure ToptionsFrm.addBtnClick(Sender: TObject);
begin bansBox.InsertRow('','',TRUE) end;

procedure ToptionsFrm.deleteBtnClick(Sender: TObject);
begin
if bansbox.strings.count > 0 then
  bansBox.Strings.Delete(bansBox.Row-1)
end;

procedure ToptionsFrm.addMimeBtnClick(Sender: TObject);
begin mimeBox.InsertRow('','',TRUE) end;

procedure ToptionsFrm.deleteMimeBtnClick(Sender: TObject);
begin
if mimeBox.strings.count > 0 then
  mimeBox.Strings.Delete(mimeBox.Row-1)
end;

procedure ToptionsFrm.addA2NbtnClick(Sender: TObject);
begin
a2nBox.insertRow('','',TRUE);
a2nBox.setFocus();
end;

procedure ToptionsFrm.deleteA2NbtnClick(Sender: TObject);
begin
if a2nBox.strings.count > 0 then
  a2nBox.Strings.Delete(a2nBox.Row-1)
end;

procedure ToptionsFrm.iconsBoxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  cnv: TCanvas;
  bmp: Tbitmap;
begin
cnv:=iconsBox.Canvas;
bmp:=Tbitmap.create;
try
  mainfrm.images.GetBitmap(index, bmp);
  cnv.FillRect(rect);
  cnv.Draw(rect.Left, rect.Top, bmp);
  cnv.TextOut(rect.Left+mainfrm.images.Width+2, rect.Top, idx_label(index));
finally bmp.free end;
end;

procedure ToptionsFrm.updateIconsBox();
// alloc enough slots. the text is not used, labels are built by the paint event
begin iconsBox.Items.Text:=dupeString(CRLF, mainfrm.images.count) end;

procedure ToptionsFrm.iconsBoxDropDown(Sender: TObject);
begin updateIconsBox() end;

procedure ToptionsFrm.ignoreLimitsChkClick(Sender: TObject);
begin
Image13.visible:=not ignoreLimitsChk.checked; //add by SilentPliz
Image2.visible:= ignoreLimitsChk.checked; //add by SilentPliz
end;

procedure ToptionsFrm.inPlaceEditBoxChange(Sender: TObject); ///mod by mars
var i:integer;
begin
inPlaceEditBox.Font.Color:=clWindowText;
inPlaceEditBox.Font.Style:=[];

for i:=0 to accountsbox.Count-1 do
  begin
  if i = accountsbox.ItemIndex then continue;
  if trim(inPlaceEditBox.Text)=accountsbox.Items.Strings[i] then
    begin
    inPlaceEditBox.Font.Color:=clRed;
    inPlaceEditBox.Font.Style:=[fsBold];
    break;
    end;
  end;
end;

procedure ToptionsFrm.inPlaceEditBoxExit(Sender: TObject); ///mod by mars
var
  old: ^string;
  b: boolean;
  i: integer;
  s:string;
  function existing():boolean;
  var
    i: integer;
  begin
  result:=TRUE;
  for i:=0 to length(tempAccounts)-1 do
    if compareText(s, tempAccounts[i].user) = 0 then
      exit;
  result:=FALSE;
  end; // existing

begin
  try
  if (accountsBox.ItemIndex >= 0) and (inPlaceEditBox.text > '')
    and (tempAccounts[accountsBox.ItemIndex].user <> inPlaceEditBox.text) then
  begin
  old:=@tempAccounts[accountsBox.ItemIndex].user;
    s:=trim(inPlaceEditBox.text);
    b:=not validUsername(s);
    if b or existing() then exit;

    for i:=0 to length(tempAccounts)-1 do
      replaceString(tempAccounts[i].link, old^, s);
      old^:=s;
    end;
  finally
  accountsbox.ScrollWidth:=0;  ///mars 05-dec-08
  inPlaceEditBox.Hide();
  accountsBox.SetFocus();
  end;
end; //inPlaceEditBoxExit

procedure ToptionsFrm.inPlaceEditBoxKeyPress(Sender: TObject; var Key: Char);
begin
if key in [#13, #27] then
  begin
  if key = #27 then inPlaceEditBox.text:='';
  inPlaceEditBox.Hide();
  key:=#0;
  end;
end;

procedure ToptionsFrm.ListView1DragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
accept:=source = sender;
end;

procedure ToptionsFrm.upBtnClick(Sender: TObject);
var
  i, dir: integer;
begin
dir:=if_(sender = upBtn, -1, +1);
i:=accountsBox.itemIndex;
if not inRange(0, i+dir, length(tempAccounts)-1) then exit;
swapItems(i, i+dir);
end;

procedure ToptionsFrm.upBtnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
accountsBox.setFocus()
end;

procedure ToptionsFrm.updateIconMap();
begin
if not iconsBox.DroppedDown then
  iconsBox.ItemIndex:=tempIcons[iconMasksBox.CaretPos.Y];
end;

procedure ToptionsFrm.iconsBoxChange(Sender: TObject);
begin tempIcons[iconMasksBox.CaretPos.Y]:=iconsBox.ItemIndex end;

procedure ToptionsFrm.iconMasksBoxChange(Sender: TObject);
begin setLength(tempIcons, iconMasksBox.Lines.count+1) end;

procedure ToptionsFrm.wiki(Sender: TObject);
begin openURL('http://www.rejetto.com/wiki/') end;

end.
